OBJ
  ldr : "OS_loader"
  vga : "OS_vgaHiresText"
  key : "OS_keyboard"

PUB windowEditor : input | p

'' This method provides an editable window on the hires VGA text screen.
'' It uses the standard PS/2 keyboard control keys including backspace,
'' cursor positioning, delete and insert (for an insert mode). This uses
'' the active window in the hires VGA text object to set the bounds of the
'' window to be used.  It is the responsibility of the caller to define
'' and clear the window, set the cursor position, and enable the cursor.
'' The edited text must be retrieved from the window by the caller.
'' Unknown or invalid control keys terminate editing and return the keycode.
'' The state of the window and the screen is such that editing can be
'' resumed after the terminating keycode is processed by the caller.

  p := long[ldr#videoPtr]
  repeat
    input := key.getKey
    case input
      $09:                                     ' Tab
        repeat
          if byte[p+vga#vga_mode] & vga#insertMask
            vga.out(vga#Insert)
          vga.out(" ")
        while (byte[p+vga#vga_col] - byte[p+vga#vga_wleft]) & 7
      $0D:                                     ' Return
        if byte[p+vga#vga_row] - byte[p+vga#vga_wtop] == byte[p+vga#vga_wrows] - 1
          return
        vga.out(vga#Cr)
      $20..$7F:                                ' Printable characters
        if byte[p+vga#vga_mode] & vga#insertMask
          vga.out(vga#Insert)
        vga.out(input)
      $C0:                                     ' Left arrow
        vga.out(vga#CursLt)
      $C1:                                     ' Right arrow 
        vga.out(vga#CursRt)                            
      $C2:                                     ' Up arrow
        if byte[p+vga#vga_row] == byte[p+vga#vga_wtop]
          return
        if byte[p+vga#vga_wrows] == 1
          return
        vga.out(vga#CursUp)
      $C3:                                     ' Down arrow
        if byte[p+vga#vga_row] - byte[p+vga#vga_wtop] == byte[p+vga#vga_wrows] - 1
          return
        if byte[p+vga#vga_wrows] == 1
          return
        else
          vga.out(vga#CursDn)
      $C4:                                     ' Home
        if byte[p+vga#vga_wrows] == 1
          return
        else
          vga.out(vga#Home)
      $C5:                                     ' End
        if byte[p+vga#vga_wrows] == 1
          return
        else
          vga.str(string(vga#MoveXY,vga#Alt00,vga#rows))
      $C8:                                     ' Backspace
        if byte[p+vga#vga_col] > byte[p+vga#vga_wleft]
          vga.out(vga#Bsp)
      $C9:                                     ' Delete
        vga.out(vga#Delete)
      $CA:                                     ' Insert
        byte[p+vga#vga_mode] ^= vga#insertMask
        vga.out(vga#Cursor)
        vga.out(%01110 ^ ((byte[p+vga#vga_mode] & vga#insertMask == 0) & 1))
      other:                                   ' All others
        return